Skip to content

# Class: LensExtension

Renderer.LensExtension

## Hierarchy

- `LensExtension`

↳ LensExtension

## Table of contents

### Constructors

- constructor

### Properties

- [Disposers]
- appPreferences
- catalogEntityDetailItems
- clusterPageMenus
- clusterPages
- commands
- entitySettings
- globalPages
- id
- isBundled
- kubeObjectDetailItems
- kubeObjectMenuItems
- kubeObjectStatusTexts
- kubeWorkloadsOverviewItems
- manifest
- manifestPath
- protocolHandlers
- statusBarItems
- topBarItems
- welcomeMenus

### Accessors

- description
- name
- version

### Methods

- disable
- enable
- getExtensionFileFolder
- isEnabledForCluster
- navigate
- onActivate
- onDeactivate

## Constructors

### constructor

• new LensExtension(`__namedParameters`)

#### Parameters

Name | Type
--- | ---
`__namedParameters` | `InstalledExtension`

#### Inherited from

LensExtension.constructor

## Properties

### [Disposers]

• [Disposers]: `ExtendableDisposer`

#### Inherited from

LensExtension.__@Disposers@25585

### appPreferences

• appPreferences: AppPreferenceRegistration[] = []

### catalogEntityDetailItems

• catalogEntityDetailItems: `CatalogEntityDetailRegistration`<CatalogEntity<CatalogEntityMetadata, CatalogEntityStatus, CatalogEntitySpec>>[] = []

### clusterPageMenus

• clusterPageMenus: ClusterPageMenuRegistration[] = []

### clusterPages

• clusterPages: PageRegistration[] = []

### commands

• commands: `CommandRegistration`[] = []

### entitySettings

• entitySettings: `EntitySettingRegistration`[] = []

### globalPages

• globalPages: PageRegistration[] = []

### id

• `Readonly` id: `string`

#### Inherited from

LensExtension.id

### isBundled

• `Readonly` isBundled: `boolean`

#### Inherited from

LensExtension.isBundled

### kubeObjectDetailItems

• kubeObjectDetailItems: KubeObjectDetailRegistration[] = []

### kubeObjectMenuItems

• kubeObjectMenuItems: KubeObjectMenuRegistration[] = []

### kubeObjectStatusTexts

• kubeObjectStatusTexts: KubeObjectStatusRegistration[] = []

### kubeWorkloadsOverviewItems

• kubeWorkloadsOverviewItems: `WorkloadsOverviewDetailRegistration`[] = []

### manifest

• `Readonly` manifest: `LensExtensionManifest`

#### Inherited from

LensExtension.manifest

### manifestPath

• `Readonly` manifestPath: `string`

#### Inherited from

LensExtension.manifestPath

### protocolHandlers

• protocolHandlers: ProtocolHandlerRegistration[] = []

#### Inherited from

LensExtension.protocolHandlers

### statusBarItems

• statusBarItems: StatusBarRegistration[] = []

### topBarItems

• topBarItems: `TopBarRegistration`[] = []

### welcomeMenus

• welcomeMenus: `WelcomeMenuRegistration`[] = []

## Accessors

### description

• `get` description(): `string`

#### Returns

`string`

### name

• `get` name(): `string`

#### Returns

`string`

### version

• `get` version(): `string`

#### Returns

`string`

## Methods

### disable

▸ disable(): `Promise`<void>

#### Returns

`Promise`<void>

#### Inherited from

LensExtension.disable

### enable

▸ enable(`register`): `Promise`<void>

#### Parameters

Name | Type
--- | ---
`register` | (`ext`: `LensExtension`) => `Promise`<Disposer[]>

#### Returns

`Promise`<void>

#### Inherited from

LensExtension.enable

### getExtensionFileFolder

▸ getExtensionFileFolder(): `Promise`<string>

getExtensionFileFolder returns the path to an already created folder. This folder is for the sole use of this extension.

Note: there is no security done on this folder, only obfuscation of the folder name.

#### Returns

`Promise`<string>

#### Inherited from

LensExtension.getExtensionFileFolder

### isEnabledForCluster

▸ isEnabledForCluster(`cluster`): `Promise`<Boolean>

Defines if extension is enabled for a given cluster. Defaults to `true`.

#### Parameters

Name | Type
--- | ---
`cluster` | `Cluster`

#### Returns

`Promise`<Boolean>

### navigate

▸ navigate<P>(`pageId?`, `params?`): `Promise`<void>

#### Type parameters

Name | Type
--- | ---
`P` | `P`: `object`

#### Parameters

Name | Type
--- | ---
`pageId?` | `string`
`params?` | `P`

#### Returns

`Promise`<void>

### onActivate

▸ `Protected` onActivate(): `void` | `Promise`<void>

#### Returns

`void` | `Promise`<void>

#### Inherited from

LensExtension.onActivate

### onDeactivate

▸ `Protected` onDeactivate(): `void` | `Promise`<void>

#### Returns

`void` | `Promise`<void>

#### Inherited from

LensExtension.onDeactivate